#include <stdio.h>
#include <string.h>
#include <netdb.h>

#define DEFAULTPROTO "ftp"

struct url *urltoaddr(char *input);

struct url
{
   char *host; /* hostname */
   char *dir; /* directory on remote, like /index.html and such */
   char *proto; /* protocol to use, ftp:// == ftp, default is http */
   unsigned short port; /* port number in standard number */
};

struct url *urltoaddr(char *input)
{
   char *temp;
   char *argvcopy=(char *)malloc(sizeof(char *) * strlen(input));
   short start=0;
   struct servent *service;
   int loop;
   struct url *tempstruct=(struct url *)malloc(sizeof(struct url *));
      
   strcpy(argvcopy,input);
   
   /* Protocol auto-detect */
   if(strstr(input,"://"))
     {
	tempstruct->proto=strtok(input,"://");
	start=strlen(tempstruct->proto)+3;
     }
   else
     tempstruct->proto=NULL;
   
   /* host auto-detect */
   if(tempstruct->proto != NULL)
     {      
	temp=strlen(tempstruct->proto) + tempstruct->proto + 1;
	tempstruct->host=strtok(temp,"/");
     }
   else
     tempstruct->host=strtok(input,"/");
   
   if (tempstruct->proto == NULL)
     tempstruct->proto=DEFAULTPROTO;
   
   
   /* lets not force people to use a terminating / */
      
   temp=argvcopy+start;
   tempstruct->dir=index(temp,'/');
   
   if (tempstruct->dir == NULL)
     tempstruct->dir="/";
   
   service = getservbyname(tempstruct->proto,NULL);
   
   if (service == NULL)
     {
	printf("Unknown service\n");
	exit(1);
     }
   
   tempstruct->port=ntohs(service->s_port);
   
   temp=index(tempstruct->host,':');
   if (temp != NULL)
     {
	temp++;
	tempstruct->port=strtoul(temp,NULL,0);
     }
   
   for (loop=0; loop < strlen(tempstruct->host); loop++)
     if (tempstruct->host[loop]==':')
       tempstruct->host[loop]='\0';

   return tempstruct;
}
